@echo off
setlocal enableextensions enabledelayedexpansion
cls
set tbwinpe_ver=1.25

echo.
echo ==============================================================================
echo   TeraByte WinPE Builder                                            ver. %tbwinpe_ver%
echo ==============================================================================
echo.


:: ===============================================================
:: ====================== Set Custom Paths =======================

:: Note: Set these paths only if not using the installation paths. 
:: Do not include a trailing backslash. Do not include any spaces before or after the equals sign.
:: Example: set ifwpath=D:\TeraByte\Image for Windows

set ifwpath=

set tbiviewpath=

set tbosdtpath=

set sourcepath=

:: ===============================================================
:: ====================== Set Build Options ======================

:: Use this option to change the screen resolution used by WinPE. The default
:: resolution is 1024x768 (-m3). For resolution options, run chgres.
set screenresolution=-m3

:: If pausebuild=1 the build will pause before unmounting the WIM file. This allows
:: advanced users to verify content or add content before build completes.
:: Set to 0 (zero) to cancel pausing.
set pausebuild=0

:: If usestartnetcmd=1 the build will use the startnet.cmd file to control program startup
:: instead of the default (winpeshl.ini).
:: Set to 0 (zero) to use the default.
set usestartnetcmd=0

:: If bootprompt=1 the CD will display the "Press any key to boot from CD/DVD" message
:: when booted and the computer will boot normally if no key is press.
:: Otherwise, set to 0 (zero) to make the CD boot directly with no prompt.
set bootprompt=0

:: Use this option to set the time zone. To see a list of valid time zones, run the
:: script and select option 3 from the menu.
:: Example (to set Eastern Time): set timezone=16
set timezone=

:: Use this option to install a language pack. To see a list of valid language
:: packs, run the script and select option 4 from the menu. The selected
:: language pack will be set as the default.
:: Example: set languagepack=FR-FR
set languagepack=

:: Use this option to set the input locale to an alternate value. The locale
:: selected must be supported by the current language pack being used.
:: Example: set inputlocale=fr-CH
set inputlocale=

:: Use this option set the screen DPI value. This can be helpful when using
:: FHD/QHD/QFHD displays that are not automatically detected correctly.
:: Default DPI will be used if option not set or specified value is invalid.
:: Set to 0 (zero) or leave blank to use the default.
:: Valid values are: 0, 96, 120, 144, 168, 192, 240, 288
set screendpi=0


:: ===============================================================
:: ===============================================================
:: ============ Don't Change Anything Below This Line ============


:: --------------------
:: Check for WOW64
if defined PROCESSOR_ARCHITEW6432 (
	if defined CMD64RESTART goto :CMDx64Required
	if not exist "%SystemRoot%\Sysnative\cmd.exe" goto :CMDx64Required
	set CMD64RESTART=1
	"%SystemRoot%\Sysnative\cmd.exe" /c %0
	goto :End
)


:: --------------------
:: Set Paths & Variables
::
set tbpath=%~dp0
set tbpath=%tbpath:~0,-1%
cd /d "%tbpath%"

set PATH=%SystemRoot%;%SystemRoot%\System32;%SystemDrive%\Windows;%SystemDrive%\Windows\System32;%PATH%

if not defined pausebuild (set pausebuild=0)
if not "%pausebuild%"=="0" if not "%pausebuild%"=="1" (set pausebuild=0)
if not defined usestartnetcmd (set usestartnetcmd=0)
if not "%usestartnetcmd%"=="0" if not "%usestartnetcmd%"=="1" (set usestartnetcmd=0)
if not defined bootprompt (set bootprompt=0)
if not "%bootprompt%"=="0" if not "%bootprompt%"=="1" (set bootprompt=0)

(set reg32opt=)
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" (set reg32opt=/reg:32)

if "%ifwpath:~0,1%"==" " (set ifwpath=)
if "%ifwpath%"=="" for /f "usebackq tokens=5,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{47BFB85A-8D4F-4c78-95CB-12A06E0C7215}_is1" %reg32opt% 2^> nul ^| find "Inno Setup: App Path"`) do set ifwpath=%%H
if "%ifwpath%"=="" for /f "usebackq tokens=5,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Image for Windows (V2)_is1" %reg32opt% 2^> nul ^| find "Inno Setup: App Path"`) do set ifwpath=%%H
if "%ifwpath%"=="" if "%PROCESSOR_ARCHITECTURE%"=="AMD64" set ifwpath=%ProgramFiles(x86)%\TeraByte Drive Image Backup and Restore Suite
if "%ifwpath%"=="" set ifwpath=%ProgramFiles%\TeraByte Drive Image Backup and Restore Suite

if "%tbiviewpath:~0,1%"==" " (set tbiviewpath=)
if "%tbiviewpath%"=="" for /f "usebackq tokens=5,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{3368C32B-A096-4e82-B9C3-76572D693A58}_is1" %reg32opt% 2^> nul ^| find "Inno Setup: App Path"`) do set tbiviewpath=%%H
if "%tbiviewpath%"=="" for /f "usebackq tokens=5,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\TBIView_is1" %reg32opt% 2^> nul ^| find "Inno Setup: App Path"`) do set tbiviewpath=%%H
if "%tbiviewpath%"=="" if "%PROCESSOR_ARCHITECTURE%"=="AMD64" set tbiviewpath=%ProgramFiles(x86)%\TeraByte Drive Image Backup and Restore Suite\TBIView
if "%tbiviewpath%"=="" set tbiviewpath=%ProgramFiles%\TeraByte Drive Image Backup and Restore Suite\TBIView

if "%tbosdtpath:~0,1%"==" " (set tbosdtpath=)
if "%tbosdtpath%"=="" for /f "usebackq tokens=5,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{6F2F51C1-3DBA-437b-B43C-8B6FF8E9FEF6}_is1" %reg32opt% 2^> nul ^| find "Inno Setup: App Path"`) do set tbosdtpath=%%H
if "%tbosdtpath%"=="" for /f "usebackq tokens=5,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{F65A10A6-905E-497A-8D4F-2776802DF4D3}_is1" %reg32opt% 2^> nul ^| find "Inno Setup: App Path"`) do set tbosdtpath=%%H
if "%tbosdtpath%"=="" for /f "usebackq tokens=5,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{F65A10A6-905E-497A-8D4F-2776802DF4C2}_is1" %reg32opt% 2^> nul ^| find "Inno Setup: App Path"`) do set tbosdtpath=%%H
if "%tbosdtpath%"=="" if "%PROCESSOR_ARCHITECTURE%"=="AMD64" set tbosdtpath=%ProgramFiles(x86)%\TeraByte Drive Image Backup and Restore Suite\TeraByte OSD Tool Suite Pro
if "%tbosdtpath%"=="" set tbosdtpath=%ProgramFiles%\TeraByte Drive Image Backup and Restore Suite\TeraByte OSD Tool Suite Pro

if "%sourcepath:~0,1%"==" " (set sourcepath=)
if "%sourcepath%"=="" for /f "usebackq tokens=2,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows Kits\Installed Roots" %reg32opt% 2^> nul ^| find "KitsRoot10"`) do set sourcepath=%%H
if "%sourcepath%"=="" for /f "usebackq tokens=2,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows Kits\Installed Roots" %reg32opt% 2^> nul ^| find "KitsRoot81"`) do set sourcepath=%%H
if "%sourcepath%"=="" for /f "usebackq tokens=2,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows Kits\Installed Roots" %reg32opt% 2^> nul ^| find "KitsRoot"`) do set sourcepath=%%H
if not "%sourcepath%"=="" if "!sourcepath:~-1!"=="\" (set sourcepath=!sourcepath:~0,-1!)
if "%sourcepath%"=="" (
	for /f "usebackq tokens=2,*" %%G in (`reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Classes\MSCIL" 2^> nul ^| find "FriendlyTypeName"`) do set sourcepath=%%H
	if not "!sourcepath!"=="" (set sourcepath=!sourcepath:~1,-29!)
	if not "!sourcepath!"=="" if not exist "!sourcepath!\Tools\Servicing\dism.exe" (set sourcepath=)
)
if "%sourcepath%"=="" if exist "%ProgramFiles(x86)%\Windows Kits\10" set sourcepath=%ProgramFiles(x86)%\Windows Kits\10
if "%sourcepath%"=="" if exist "%ProgramFiles%\Windows Kits\10" set sourcepath=%ProgramFiles%\Windows Kits\10
if "%sourcepath%"=="" if exist "%ProgramFiles(x86)%\Windows Kits\8.1" set sourcepath=%ProgramFiles(x86)%\Windows Kits\8.1
if "%sourcepath%"=="" if exist "%ProgramFiles%\Windows Kits\8.1" set sourcepath=%ProgramFiles%\Windows Kits\8.1
if "%sourcepath%"=="" if exist "%ProgramFiles(x86)%\Windows Kits\8.0" set sourcepath=%ProgramFiles(x86)%\Windows Kits\8.0
if "%sourcepath%"=="" if exist "%ProgramFiles%\Windows Kits\8.0" set sourcepath=%ProgramFiles%\Windows Kits\8.0
if "%sourcepath%"=="" set sourcepath=%ProgramFiles%\Windows AIK

(set sourcetype=0)

(set tbx64=)
(set buildarch=x86)
(set createbootfile=0)

if "%timezone:~0,1%"==" " (set timezone=0)
if "%timezone%"=="" (set timezone=0)
if "%languagepack:~0,1%"==" " (set languagepack=)
if "%inputlocale:~0,1%"==" " (set inputlocale=)

set /a usesavedsettings=0
for /f "usebackq tokens=* delims=" %%G in (`tbutil -iniread SavedSettings.ini -s Options -k UseSavedSettings -d 0`) do set usesavedsettings=%%G
if %usesavedsettings% NEQ 1 (set /a usesavedsettings=0)

if not defined screendpi (set /a screendpi=0)


:: --------------------
:: Check tbutil version
tbutil -filever tbutil.exe -c 1.26 > nul
if %errorlevel% LSS 3 (
	echo.
	echo Error: Requires tbutil version 1.26 or later.
	echo.
	echo Script aborted.
	echo.
	tbutil -pause -m "Press any key to exit script..."
	goto :End
)


:: --------------------
:: Display Menu
tbutil -console -row
if %errorlevel% LSS 26 tbutil -console -row 26
:DisplayMenu
cls
tbutil -adkver -x86
if %errorlevel% LSS 2 (set Supportx86=1) else (set Supportx86=0)
if %usesavedsettings% EQU 1 (set MSS_Status=Saved settings will be used for build) else if exist SavedSettings.ini (set MSS_Status=Saved settings will not be used for build) else (set MSS_Status=Saved settings not found)
echo.
echo ==============================================================================
echo   TeraByte WinPE Builder                                            ver. %tbwinpe_ver%
echo ==============================================================================
echo.
echo.
echo Please make a selection from the following choices:
echo.
if %Supportx86% EQU 0 goto :Menu2
echo   1 - Build 32-bit (x86) TBWinPE
if %createbootfile% EQU 1 echo         (Boot file TBWinPE.bin will be created)
echo.
echo   2 - Build 64-bit (AMD64) TBWinPE
if %createbootfile% EQU 1 echo         (Boot file TBWinPE.bin will be created)
echo.
echo   3 - Toggle creating boot file for use with TeraByte's BOOTFILE program
echo.
echo   4 - List Time Zone codes
echo.
echo   5 - List available Language Packs
echo.
echo   6 - Manage saved settings [%MSS_Status%]
echo.
echo   7 - Exit script
echo.
tbutil -choice -c 1234567 -m "Press the number of your selection: "
goto :MenuFinish
:Menu2
echo   1 - Build 64-bit (AMD64) TBWinPE
if %createbootfile% EQU 1 echo         (Boot file TBWinPE.bin will be created)
echo.
echo   2 - Toggle creating boot file for use with TeraByte's BOOTFILE program
echo.
echo   3 - List Time Zone codes
echo.
echo   4 - List available Language Packs
echo.
echo   5 - Manage saved settings [%MSS_Status%]
echo.
echo   6 - Exit script
echo.
tbutil -choice -c 123456 -e 2,3,4,5,6,7 -m "Press the number of your selection: "
:MenuFinish
if %errorlevel% EQU 7 goto :End
if %errorlevel% EQU 6 goto :ManageSettings
if %errorlevel% EQU 5 call :ShowLangPacks & goto :End
if %errorlevel% EQU 4 call :ShowTimeZones & goto :End
if %errorlevel% EQU 3 (
	if %createbootfile% EQU 0 (set createbootfile=1)
	if %createbootfile% EQU 1 (set createbootfile=0)
	goto :DisplayMenu
)
if %errorlevel% EQU 0 echo Error: Invalid build mode. & goto :End
if %errorlevel% EQU 2 (set tbx64=64) & (set buildarch=AMD64)
echo.
echo.
if "%tbx64%"=="64" (echo Creating 64-bit TBWinPE...) else (echo Creating 32-bit TBWinPE...)


:: --------------------
:: Apply saved settings
if exist SavedSettings_Apply.cmd del SavedSettings_Apply.cmd > nul
if exist TBLauncher_Saved.ini del TBLauncher_Saved.ini > nul
if exist startnet_Saved.cmd del startnet_Saved.cmd > nul
tbutil -applysavedbuildsettings
if %errorlevel% EQU 0 if %usesavedsettings% EQU 1 (
	echo.
	echo Using saved settings...
	if exist SavedSettings_Apply.cmd (
		call SavedSettings_Apply.cmd
		del SavedSettings_Apply.cmd > nul
	)
)
if exist "%sourcepath%\Assessment and Deployment Kit\Windows Preinstallation Environment\copype.cmd" (set sourcetype=1)


:: --------------------
:: Check if WAIK/ADK is installed, DISM.EXE is available, and WIM exists
echo.
(set FileVer_dism=)
set BuildSourceName=Unknown
if %sourcetype% EQU 0 (
	set BuildSourceName=Windows 7 AIK
	echo Using !BuildSourceName!... 
	set dismpath=!sourcepath!\Tools\Servicing
	set winpesource=!sourcepath!\Tools\PETools\%buildarch%
	if not exist "!dismpath!\dism.exe" goto :NoDISM
	set FileVer_dism=6.1
)
if %sourcetype% EQU 1 (
	set dismpath=!sourcepath!\Assessment and Deployment Kit\Deployment Tools\%PROCESSOR_ARCHITECTURE%\DISM
	set winpesource=!sourcepath!\Assessment and Deployment Kit\Windows Preinstallation Environment\%buildarch%\en-us
	if not exist "!dismpath!\dism.exe" goto :NoDISM
	tbutil -adkver
	set ADKVer=!errorlevel!
	if !ADKVer! EQU 4 (set BuildSourceName=Windows 11 ADK)
	if !ADKVer! EQU 3 (set BuildSourceName=Windows 10 ADK)
	if !ADKVer! EQU 2 (set BuildSourceName=Windows 8.1 ADK)
	if !ADKVer! EQU 1 (set BuildSourceName=Windows 8.0 ADK)
	echo Using !BuildSourceName!... 
)
if not exist "%winpesource%\winpe.wim" goto :WinPEWimNotFound


:: --------------------
:: Check if script has administrator privileges
"%dismpath%\dism.exe" > nul
if %errorlevel% EQU 740 goto :NonAdmin


:: --------------------
:: Check if IFW is installed
if not exist "%ifwpath%\imagew%tbx64%.exe" goto :NoIFW
(set VerIFW=0)
for /f "usebackq tokens=* delims=" %%G in (`tbutil -filever "%ifwpath%\imagew%tbx64%.exe"`) do set VerIFWStr=%%G
if "%VerIFWStr:~0,1%"=="2" (set VerIFW=2)
if "%VerIFWStr:~0,1%"=="3" (set VerIFW=3)
if "%VerIFW%"=="0" goto :NoIFW


:: --------------------
:: Check if TBOSDT is installed (required for bootfile)
if %createbootfile% EQU 1 (
	if not exist "%tbosdtpath%\win\tbosdtw.exe" goto :NoTBOSDT
	if not exist "%tbosdtpath%\win\tbosdtw64.exe" goto :NoTBOSDT
	if not exist "%tbosdtpath%\win\bootfile.exe" goto :NoTBOSDT
	if not exist "%tbosdtpath%\win\bootfile64.exe" goto :NoTBOSDT

	tbutil -filever "!tbosdtpath!\win\tbosdtw.exe" -c 1.47 > nul
	if !errorlevel! LSS 3 goto :NoTBOSDT
	tbutil -filever "!tbosdtpath!\win\tbosdtw64.exe" -c 1.47 > nul
	if !errorlevel! LSS 3 goto :NoTBOSDT
	tbutil -filever "!tbosdtpath!\win\bootfile.exe" -c 2.0.5 > nul
	if !errorlevel! LSS 3 goto :NoTBOSDT
	tbutil -filever "!tbosdtpath!\win\bootfile64.exe" -c 2.0.5 > nul
	if !errorlevel! LSS 3 goto :NoTBOSDT
)


:: --------------------
:: Check if IFW key is available
if %VerIFW% EQU 3 goto :LicenseV3Check
if not exist imagew.ini (
	echo ; This file contains the license key for Image for Windows.> imagew.ini
	echo ; Enter the key in the following format: Name Key>> imagew.ini
	echo ;>> imagew.ini
	echo ; If the key is missing or invalid, Image for Windows will run in trial mode.>> imagew.ini
	echo ;>> imagew.ini
	echo ; For example:>> imagew.ini
	echo ;>> imagew.ini
	echo ; [License]>> imagew.ini
	echo ; Key=John Smith 000000-111111-222222-333333-444444-555555-666666-777777-888888-999999>> imagew.ini
	echo ;>> imagew.ini
	echo [License]>> imagew.ini
	echo Key=>> imagew.ini
)
if not exist imagew.ini (
	echo.
	echo Unable to create imagew.ini file. Script aborted.
	echo.
	tbutil -pause -m "Press any key to exit script..."
	goto :End
)
:CheckImagewFile
tbutil -checkkey
if %errorlevel% EQU 3 goto :SkipLicenseCheck
echo.
echo --------------------------------------------------------------------------
echo --[ Warning ]-------------------------------------------------------------
echo --------------------------------------------------------------------------
echo The imagew.ini file does not appear to contain a valid Product Key.
echo If the product key is not valid, Image for Windows will run in trial mode.
echo.
echo What would you like to do?
echo.
echo   1 - Use existing imagew.ini file and continue
echo       (select this option if using the trial version of IFW)
echo.
echo   2 - Edit the imagew.ini file using Notepad
echo       (the script will continue after Notepad exits)
echo.
echo   3 - Exit script
echo.
tbutil -choice -c 123 -m "Press the number of your selection: "
if %errorlevel% EQU 3 goto :End
if %errorlevel% EQU 0 echo Error: Invalid selection. & goto :End
if %errorlevel% EQU 2 (
	notepad imagew.ini
	echo. & echo.
	goto :CheckImagewFile
)
goto :SkipLicenseCheck

:: Check IFW V3 License
:LicenseV3Check
if not exist LicenseV3.ini (
	echo ; This file contains the license key for Image for Windows V3.> LicenseV3.ini
	echo ; Enter the key in the format detailed below.>> LicenseV3.ini
	echo ;>> LicenseV3.ini
	echo ; If the key is missing or invalid, Image for Windows will not run.>> LicenseV3.ini
	echo ;>> LicenseV3.ini
	echo ; For example:>> LicenseV3.ini
	echo ;>> LicenseV3.ini
	echo ; [License]>> LicenseV3.ini
	echo ; ProductKey=1111-2222-3333-4444-5555-6666>> LicenseV3.ini
	echo ; User=John Smith>> LicenseV3.ini
	echo ;>> LicenseV3.ini
	echo [License]>> LicenseV3.ini
	echo ProductKey=>> LicenseV3.ini
	echo User=>> LicenseV3.ini
)
if not exist LicenseV3.ini (
	echo.
	echo Unable to create LicenseV3.ini file. Script aborted.
	echo.
	tbutil -pause -m "Press any key to exit script..."
	goto :End
)
:CheckLicenseV3iniFile
tbutil -checkkey
if %errorlevel% EQU 3 goto :SkipLicenseCheck
echo ----------------------------------------------------------------------------
echo --[ Product Key Notice ]----------------------------------------------------
echo ----------------------------------------------------------------------------
echo The licensed name and product key for Image for Windows V3 were not found 
echo or appear invalid. If the name or product key is missing or not valid 
echo Image for Windows will prompt for them when run. If using the trial version
echo of Image for Windows select option 2 below.
echo.
echo What would you like to do?
echo.
echo   1 - Apply license key to build (script will continue after Notepad exits)
echo.
echo   2 - Continue without license key (valid only for trial version)
echo.
echo   3 - Exit script
echo.
tbutil -choice -c 123 -m "Press the number of your selection: "
if %errorlevel% EQU 3 goto :End
if %errorlevel% EQU 0 echo Error: Invalid selection. & goto :End
if %errorlevel% EQU 1 (
	notepad LicenseV3.ini
	echo. & echo.
	goto :CheckLicenseV3iniFile
)
:SkipLicenseCheck


:: --------------------
:: Copy the WinPE files to ISO folder for processing
echo.
echo Copying WinPE files...
if exist "ISO\boot" rd /s /q "ISO\boot" > nul
if exist "ISO\EFI" rd /s /q "ISO\EFI" > nul
if exist "ISO\bootmgr" del "ISO\bootmgr*.*" > nul
if exist "ISO\??-*" for /f "delims=" %%G in ('dir /b /ad /p /-p "ISO\??-*"') do (rd /s /q "ISO\%%G")
if not exist "ISO" md "ISO" > nul
if exist "etfsboot.com" del "etfsboot.com" > nul
if exist "efisys.bin" del "efisys.bin" > nul
if exist "efisys_noprompt.bin" del "efisys_noprompt.bin" > nul
if not exist "ISO\TBData" md "ISO\TBData"
if exist "ISO\TBData\TBWinRE.txt" del "ISO\TBData\TBWinRE.txt" > nul
if %sourcetype% EQU 0 (
:: -----Windows 7 AIK
	if exist "!winpesource!\bootmgr" copy "!winpesource!\bootmgr" "ISO" > nul
	if exist "!winpesource!\bootmgr.efi" copy "!winpesource!\bootmgr.efi" "ISO" > nul
	if exist "!winpesource!\boot\etfsboot.com" copy "!winpesource!\boot\etfsboot.com" "!tbpath!" > nul
	if exist "!winpesource!\boot\efisys.bin" copy "!winpesource!\boot\efisys.bin" "!tbpath!" > nul
	if exist "!winpesource!\boot\efisys_noprompt.bin" copy "!winpesource!\boot\efisys_noprompt.bin" "!tbpath!" > nul
	if exist "!winpesource!\boot" xcopy /cherky "!winpesource!\boot" "ISO\boot\" > nul
	if "%tbx64%"=="64" if exist "!winpesource!\EFI" xcopy /cherky "!winpesource!\EFI" "ISO\EFI\" > nul
	if not exist "ISO\sources" md "ISO\sources" > nul
	copy "!winpesource!\winpe.wim" "ISO\sources\boot.wim" > nul
	set PATH=!PATH!;!sourcepath!\Tools\PETools;!sourcepath!\Tools\%PROCESSOR_ARCHITECTURE%
)
if %sourcetype% EQU 1 (
:: -----Windows 8 ADK
	copy "!winpesource!\..\Media\bootmgr.*" "ISO" > nul
	xcopy /cherky "!winpesource!\..\Media\boot" "ISO\boot\" > nul
	xcopy /cherky "!winpesource!\..\Media\EFI" "ISO\EFI\" > nul
	copy "!dismpath!\..\..\%buildarch%\Oscdimg\etfsboot.com" "!tbpath!" > nul
	copy "!dismpath!\..\..\%buildarch%\Oscdimg\efisys.bin" "!tbpath!" > nul
	copy "!dismpath!\..\..\%buildarch%\Oscdimg\efisys_noprompt.bin" "!tbpath!" > nul
	if not exist "ISO\sources" md "ISO\sources" > nul
	copy "!winpesource!\winpe.wim" "ISO\sources\boot.wim" > nul
	set PATH=!PATH!;!dismpath!
	if not "%languagepack%"=="" if exist "!winpesource!\..\Media\%languagepack%" (
		xcopy /cherky "!winpesource!\..\Media\%languagepack%" "ISO\%languagepack%\" > nul
		"!dismpath!\..\BCDBoot\bcdedit" /store "ISO\boot\BCD" /set {bootmgr} locale %languagepack% > nul
		"!dismpath!\..\BCDBoot\bcdedit" /store "ISO\EFI\Microsoft\Boot\BCD" /set {bootmgr} locale %languagepack% > nul
	)
)
:: Process bootprompt option
if %bootprompt% EQU 0 (
	if exist "ISO\boot\bootfix.bin" del "ISO\boot\bootfix.bin" > nul
	if exist "!tbpath!\efisys_noprompt.bin" copy "!tbpath!\efisys_noprompt.bin" "!tbpath!\efisys.bin" > nul
)
if exist "%tbpath%\efisys_noprompt.bin" del "%tbpath%\efisys_noprompt.bin" > nul


:: --------------------
:: Mount the WinPE image for processing
(set foldermounted=)
"%dismpath%\dism" /get-mountedwiminfo | find /i "%tbpath%\mount" > "WinPE_dism.tmp"
for /f "usebackq tokens=1,2,3 delims=:" %%G in (`type "WinPE_dism.tmp"`) do set foldermounted=%%I
del "WinPE_dism.tmp"
if not "%foldermounted%"=="" (
	echo. & echo WARNING: Mount folder in use. Attempting cleanup...
	tbutil -cleanupwimmount
	if !errorlevel! NEQ 1 echo WARNING: Error performing mount cleanup!
	"!dismpath!\Dism" /unmount-Wim /MountDir:"mount" /discard
	rd /s /q "mount" > nul
	"!dismpath!\Dism" /cleanup-wim > nul
)
echo.
echo Mounting WinPE image...
if exist "mount" rd /s /q "mount" > nul
if not exist "mount" md "mount"
"%dismpath%\Dism" /Mount-Wim /WimFile:"ISO\sources\boot.wim" /index:1 /MountDir:"mount"
if %errorlevel% EQU 0 goto :skipMountError
echo.
echo --------------------------------------------------------------------------
echo --[ Mount Error ]---------------------------------------------------------
echo --------------------------------------------------------------------------
echo The WinPE image couldn't be mounted successfully. Please make sure
echo no programs (e.g. Explorer) are currently accessing the mount folder 
echo and that the mount folder is empty. Then press a key to attempt 
echo another mount.
echo.
echo Mount folder: %tbpath%\mount
echo --------------------------------------------------------------------------
echo.
tbutil -pause -m "Press any key to try the mount again..."
echo.
echo Mounting WinPE image (2nd attempt)...
if exist "mount" rd /s /q "mount" > nul
"%dismpath%\Dism" /cleanup-wim
if not exist "mount" md "mount"
"%dismpath%\Dism" /Mount-Wim /WimFile:"ISO\sources\boot.wim" /index:1 /MountDir:"mount"
if %errorlevel% NEQ 0 goto :DISMMountError
:skipMountError


:: ---------------------
:: Set Language Pack & Locale
:: ---------------------
if not "%languagepack%"=="" (
	echo.
	echo Adding language pack %languagepack%...
	if %sourcetype% EQU 0 "!dismpath!\dism" /add-package /packagepath:"!sourcepath!\Tools\PETools\%buildarch%\WinPE_FPs\%languagepack%\LP_%languagepack%.CAB" /image:"mount"
	if %sourcetype% EQU 1 "!dismpath!\dism" /add-package /packagepath:"!winpesource!\..\WinPE_OCs\%languagepack%\lp.cab" /image:"mount"
	"!dismpath!\dism" /set-allintl:%languagepack% /image:"mount"
)
if not "%inputlocale%"=="" (
	echo.
	echo Setting input locale %inputlocale%...
	"!dismpath!\dism" /set-inputlocale:%inputlocale% /image:"mount"
)


:: ---------------------
:: Set Time Zone
:: ---------------------
if %timezone% GTR 0 if %timezone% LSS 99 (
	echo. & echo Setting time zone...
	call :ShowTimeZoneItem %timezone%
	echo Time zone name: !timezonestr!
	"!dismpath!\dism" /image:"mount" /Set-TimeZone:"!timezonestr!"
)


:: ---------------------
:: Modify WIM startup
:: ---------------------
if exist "mount\setup.exe" (
	ren "mount\setup.exe" setup_tb_.exe > nul
	attrib +h "mount\setup_tb_.exe" > nul
)
attrib -r "mount\Windows\System32\winpeshl.ini" > nul
if exist "mount\Windows\System32\winpeshl.ini" del "mount\Windows\System32\winpeshl.ini" > nul
if exist "mount\Windows\System32\setup.bmp" del "mount\Windows\System32\setup.bmp" > nul
echo [LaunchApps] > "mount\Windows\System32\winpeshl.ini"
tbutil -filever "mount\Windows\System32\winpeshl.exe" -c 6.3 > nul
(set FileVer_winpeshl=%errorlevel%)
if %FileVer_winpeshl% GEQ 3 (
	if %createbootfile% EQU 1 echo %%SystemDrive%%\Windows\System32\bootfile.exe, /restore /noui /notifyos >> "mount\Windows\System32\winpeshl.ini"
	echo %%SystemDrive%%\Windows\System32\chgres.exe, !screenresolution! >> "mount\Windows\System32\winpeshl.ini"
)
if %FileVer_winpeshl% LEQ 2 (
	if %createbootfile% EQU 1 echo %%SystemDrive%%\Windows\System32\bootfile.exe, "/restore /noui /notifyos" >> "mount\Windows\System32\winpeshl.ini"
	echo %%SystemDrive%%\Windows\System32\chgres.exe, "!screenresolution!" >> "mount\Windows\System32\winpeshl.ini"
)
echo %%SystemDrive%%\Windows\System32\tblauncher.exe >> "mount\Windows\System32\winpeshl.ini"
if %usestartnetcmd% EQU 1 del "mount\Windows\System32\winpeshl.ini"
reg load HKLM\TBWINPE_SYSTEM "mount\windows\system32\config\system" > nul
reg add "HKLM\TBWINPE_SYSTEM\ControlSet001\Control\Session Manager\Environment" /v TBWinPE /t REG_SZ /d "1" /f > nul
if not exist "mount\Windows\System32\config\systemprofile\Desktop" md "mount\Windows\System32\config\systemprofile\Desktop"
reg load HKLM\TBWINPE_SOFTWARE "mount\windows\system32\config\software" > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\CLSID\{AE054212-3535-4430-83ED-D501AA6680E6}" /ve /t REG_SZ /d "Shell Name Space ListView" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\CLSID\{AE054212-3535-4430-83ED-D501AA6680E6}\InProcserver32" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\explorerframe.dll" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\CLSID\{AE054212-3535-4430-83ED-D501AA6680E6}\InProcserver32" /v ThreadingModel /t REG_SZ /d "Apartment" /f > nul
reg load HKLM\TBWINPE_DEFAULT "mount\windows\system32\config\default" > nul
reg add "HKLM\TBWINPE_DEFAULT\Control Panel\Desktop" /t REG_SZ /v "WallpaperStyle" /d "2" /f > nul
if "%PROCESSOR_ARCHITECTURE%"=="AMD64" (
	if "%tbx64%"=="64" copy "%SystemRoot%\System32\explorerframe.dll" "mount\Windows\System32" > nul
	if "%tbx64%"=="" copy "%SystemRoot%\SysWOW64\explorerframe.dll" "mount\Windows\System32" > nul
)
if "%PROCESSOR_ARCHITECTURE%"=="x86" (
	if "%tbx64%"=="" copy "%SystemRoot%\System32\explorerframe.dll" "mount\Windows\System32" > nul
)


:: ---------------------
:: Add TBLauncher
:: ---------------------
echo.
echo Adding TBLauncher...
copy "tblauncher%tbx64%.exe" "mount\Windows\system32\TBLauncher.exe" > nul
copy "tblauncher.ini" "mount\Windows\system32" > nul
if exist "mount\Windows\system32\InitScript.cmd" del "mount\Windows\system32\InitScript.cmd" > nul
if exist "mount\Windows\system32\RunScript.cmd" del "mount\Windows\system32\RunScript.cmd" > nul
if exist InitScript.cmd copy InitScript.cmd "mount\Windows\system32" > nul
if exist RunScript.cmd copy RunScript.cmd "mount\Windows\system32" > nul
if %usesavedsettings% EQU 1 if exist TBLauncher_Saved.ini (
	copy TBLauncher_Saved.ini "mount\Windows\system32\TBLauncher.ini" > nul
	del TBLauncher_Saved.ini > nul
)


:: ---------------------
:: Add IFW
:: ---------------------
echo.
echo Adding Image for Windows...
(set TBProgPathIFW=TeraByte Drive Image Backup and Restore Suite)
if %VerIFW% EQU 2 (set TBProgPathIFW=TeraByte Unlimited\Image for Windows\V2)
if not exist "mount\Program Files\%TBProgPathIFW%" md "mount\Program Files\%TBProgPathIFW%"
copy "%ifwpath%\imagew%tbx64%.exe" "mount\Program Files\%TBProgPathIFW%\imagew.exe" > nul
if "%tbx64%"=="64" copy "%ifwpath%\imagew64.exe" "mount\Program Files\%TBProgPathIFW%" > nul
copy "%ifwpath%\cdboot.f35" "mount\Program Files\%TBProgPathIFW%" > nul
copy "%ifwpath%\cdboot.ifd" "mount\Program Files\%TBProgPathIFW%" > nul
copy "%ifwpath%\ifw.ini" "mount\Program Files\%TBProgPathIFW%" > nul
copy "ifw.ini" "mount\Program Files\%TBProgPathIFW%" > nul
copy "%ifwpath%\ifwlang%tbx64%.dll" "mount\Program Files\%TBProgPathIFW%" > nul
copy "%ifwpath%\partinfg%tbx64%.exe" "mount\Program Files\%TBProgPathIFW%\partinfg.exe" > nul
copy "%ifwpath%\tboflhelper%tbx64%.sys" "mount\Program Files\%TBProgPathIFW%\" > nul
if exist "%ifwpath%\cdboot.ifl" (
	copy "%ifwpath%\cdboot.ifl" "mount\Program Files\%TBProgPathIFW%" > nul
	xcopy /e /y /r /i "%ifwpath%\cdboot" "mount\Program Files\%TBProgPathIFW%\cdboot" > nul
)
if %VerIFW% EQU 2 if exist "imagew.ini" (
	if exist "mount\Program Files\%TBProgPathIFW%\imagew.ini" attrib -r "mount\Program Files\%TBProgPathIFW%\imagew.ini" > nul
	copy "imagew.ini" "mount\Program Files\%TBProgPathIFW%" > nul
	if "%tbx64%"=="64" copy "imagew.ini" "mount\Program Files\%TBProgPathIFW%\imagew64.ini" > nul
)
reg add "HKLM\TBWINPE_SOFTWARE\Classes\TBIFile" /ve /t REG_SZ /d "TeraByte Image File" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\TBIFile\DefaultIcon" /ve /t REG_SZ /d "X:\Program Files\%TBProgPathIFW%\imagew.exe,0" /f > nul
:: Create imagew.cmd
echo @echo off > "mount\Windows\System32\imagew.cmd"
echo start "IFW" "%%SystemDrive%%\Program Files\%TBProgPathIFW%\imagew.exe" >> "mount\Windows\System32\imagew.cmd"


:: ---------------------
:: Add TBIView
:: ---------------------
if not exist "%tbiviewpath%\tbiview%tbx64%.exe" goto :skipTBIView
echo.
echo Adding TBIView...
(set TBProgPathTBIView=TeraByte Drive Image Backup and Restore Suite\TBIView)
if %VerIFW% EQU 2 (set TBProgPathTBIView=TeraByte Unlimited\TBIView)
if not exist "mount\Program Files\%TBProgPathTBIView%" md "mount\Program Files\%TBProgPathTBIView%"
copy "%tbiviewpath%\tbiview%tbx64%.exe" "mount\Program Files\%TBProgPathTBIView%\tbiview.exe" > nul
if "%tbx64%"=="64" copy "%tbiviewpath%\tbiview64.exe" "mount\Program Files\%TBProgPathTBIView%" > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\.tbi" /ve /t REG_SZ /d "TBIViewFile" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\TBIViewFile" /ve /t REG_SZ /d "TeraByte Image File" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\TBIViewFile\DefaultIcon" /ve /t REG_SZ /d "X:\Program Files\%TBProgPathTBIView%\tbiview.exe,0" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\TBIViewFile\shell\open" /v Icon /t REG_SZ /d "X:\Program Files\%TBProgPathTBIView%\tbiview.exe,0" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\TBIViewFile\shell\open\command" /ve /t REG_SZ /d "\"X:\Program Files\%TBProgPathTBIView%\tbiview.exe\" \"%%1\"" /f > nul
:: Create tbiview.cmd
echo @echo off > "mount\Windows\System32\tbiview.cmd"
echo start "TBIView" "%%SystemDrive%%\Program Files\%TBProgPathTBIView%\tbiview.exe" >> "mount\Windows\System32\tbiview.cmd"
:: ---------------------
:skipTBIView


:: ---------------------
:: Add TBIMount
:: ---------------------
if not exist "%tbiviewpath%\tbimount%tbx64%.exe" goto :skipTBIMount
echo.
echo Adding TBIMount...
(set TBProgPathTBIView=TeraByte Drive Image Backup and Restore Suite\TBIView)
if %VerIFW% EQU 2 (set TBProgPathTBIView=TeraByte Unlimited\TBIView)
if not exist "mount\Program Files\%TBProgPathTBIView%" md "mount\Program Files\%TBProgPathTBIView%"
if "%tbx64%"=="64" copy "%tbiviewpath%\tbimount.x64.sys" "mount\Windows\System32\Drivers\tbimount.sys" > nul
if "%tbx64%"=="" copy "%tbiviewpath%\tbimount.xp.sys" "mount\Windows\System32\Drivers\tbimount.sys" > nul
copy "%tbiviewpath%\tbimount%tbx64%.exe" "mount\Program Files\%TBProgPathTBIView%\tbimount.exe" > nul
if "%tbx64%"=="64" copy "%tbiviewpath%\tbimount64.exe" "mount\Program Files\%TBProgPathTBIView%" > nul
reg add HKLM\TBWINPE_SYSTEM\ControlSet001\Services\TBIMount /f > nul
reg add HKLM\TBWINPE_SYSTEM\ControlSet001\Services\TBIMount /v Type /t REG_DWORD /d 1 /f > nul
reg add HKLM\TBWINPE_SYSTEM\ControlSet001\Services\TBIMount /v Start /t REG_DWORD /d 3 /f > nul
reg add HKLM\TBWINPE_SYSTEM\ControlSet001\Services\TBIMount /v ErrorControl /t REG_DWORD /d 1 /f > nul
reg add HKLM\TBWINPE_SYSTEM\ControlSet001\Services\TBIMount /v DisplayName /t REG_SZ /d TBIMount /f > nul
reg add HKLM\TBWINPE_SYSTEM\ControlSet001\Services\TBIMount /v ImagePath /t REG_SZ /d "system32\drivers\tbimount.sys" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\TBIViewFile\shell\Mount as Drive Letter" /v Icon /t REG_SZ /d "X:\Program Files\%TBProgPathTBIView%\tbimount.exe,0" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\TBIViewFile\shell\Mount as Drive Letter\command" /ve /t REG_SZ /d "\"X:\Program Files\%TBProgPathTBIView%\tbimount.exe\" mount * \"%%1\"" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\Drive\shell\TBIMount - Unmount Drive Letter" /v Icon /t REG_SZ /d "X:\Program Files\%TBProgPathTBIView%\tbimount.exe,0" /f > nul
reg add "HKLM\TBWINPE_SOFTWARE\Classes\Drive\shell\TBIMount - Unmount Drive Letter\command" /ve /t REG_SZ /d "\"X:\Program Files\%TBProgPathTBIView%\tbimount.exe\" unmount %%1" /f > nul
:: Create tbimount.cmd
echo @echo off > "mount\Windows\System32\tbimount.cmd"
echo start "TBIMount" "%%SystemDrive%%\Program Files\%TBProgPathTBIView%\tbimount.exe" >> "mount\Windows\System32\tbimount.cmd"
:: ---------------------
:skipTBIMount


:: ---------------------
:: Add TBIHD
:: ---------------------
if %VerIFW% EQU 2 goto :skipTBIHD
if not exist "%tbiviewpath%\tbihd\tbihd%tbx64%.exe" goto :skipTBIHD
if "%tbx64%"=="64" if not exist "%tbiviewpath%\tbihd\setupx64.exe" goto :skipTBIHD
if "%tbx64%"=="" if not exist "%tbiviewpath%\tbihd\setup.exe" goto :skipTBIHD
echo.
echo Adding TBIHD...
(set TBProgPathTBIView=TeraByte Drive Image Backup and Restore Suite\TBIView)
if not exist "mount\Program Files\%TBProgPathTBIView%\tbihd" md "mount\Program Files\%TBProgPathTBIView%\tbihd"
copy "%tbiviewpath%\tbihd\tbihd%tbx64%.exe" "mount\Program Files\%TBProgPathTBIView%\tbihd\tbihd.exe" > nul
copy "%tbiviewpath%\tbihd\tbihd_w*" "mount\Program Files\%TBProgPathTBIView%\tbihd" > nul
if "%tbx64%"=="64" (
	copy "%tbiviewpath%\tbihd\setupx64.exe" "mount\Program Files\%TBProgPathTBIView%\tbihd\setup.exe" > nul
	if not exist "mount\Program Files\%TBProgPathTBIView%\tbihd\x64" md "mount\Program Files\%TBProgPathTBIView%\tbihd\x64"
	copy "%tbiviewpath%\tbihd\x64\*.*" "mount\Program Files\%TBProgPathTBIView%\tbihd\x64" > nul
)
if "%tbx64%"=="" (
	copy "%tbiviewpath%\tbihd\setup.exe" "mount\Program Files\%TBProgPathTBIView%\tbihd\setup.exe" > nul
	if not exist "mount\Program Files\%TBProgPathTBIView%\tbihd\x86" md "mount\Program Files\%TBProgPathTBIView%\tbihd\x86"
	copy "%tbiviewpath%\tbihd\x86\*.*" "mount\Program Files\%TBProgPathTBIView%\tbihd\x86" > nul
)
:: Create tbihd.cmd
echo @echo off > "mount\Windows\System32\tbihd.cmd"
echo start "TBIHD" "%%SystemDrive%%\Program Files\%TBProgPathTBIView%\tbihd\tbihd.exe" >> "mount\Windows\System32\tbihd.cmd"
:: ---------------------
:skipTBIHD


:: ---------------------
:: Add TBOSDT
:: ---------------------
if not exist "%tbosdtpath%\win\tbosdtw%tbx64%.exe" goto :skipTBOSDT
echo.
echo Adding TeraByte OSD Tool Suite Pro (TBOSDT)...
(set TBProgPathTBOSDT=TeraByte Drive Image Backup and Restore Suite\TeraByte OSD Tool Suite Pro)
if %VerIFW% EQU 2 (set TBProgPathTBOSDT=TeraByte Unlimited\TeraByte OSD Tool Suite Pro)
if not exist "mount\Program Files\%TBProgPathTBOSDT%\win" md "mount\Program Files\%TBProgPathTBOSDT%\win"
if not exist "mount\Program Files\%TBProgPathTBOSDT%\scripts" md "mount\Program Files\%TBProgPathTBOSDT%\scripts"
if not exist "mount\Program Files\%TBProgPathTBOSDT%\scripts\public" md "mount\Program Files\%TBProgPathTBOSDT%\scripts\public"
copy "%tbosdtpath%\win\*.*" "mount\Program Files\%TBProgPathTBOSDT%\win" > nul
copy "%tbosdtpath%\scripts\*.*" "mount\Program Files\%TBProgPathTBOSDT%\scripts" > nul
if exist "%tbosdtpath%\scripts\public" xcopy /e /y /r "%tbosdtpath%\scripts\public\*.*" "mount\Program Files\%TBProgPathTBOSDT%\scripts\public" > nul
copy "mount\Program Files\%TBProgPathTBOSDT%\win\bootfile%tbx64%.exe" "mount\Windows\System32\bootfile.exe" > nul
:: Create tbosdtw.cmd
echo @echo off > "mount\Windows\System32\tbosdtw.cmd"
echo start "TBOSDT" "%%SystemDrive%%\Program Files\%TBProgPathTBOSDT%\win\tbosdtw%tbx64%.exe" >> "mount\Windows\System32\tbosdtw.cmd"
:skipTBOSDT


:: ---------------------
:: Configure WinPE
:: ---------------------
echo.
echo Configuring WinPE...
tbutil -configurewinpe
if %errorlevel% NEQ 1 echo WARNING: Error configuring WinPE!
tbutil -configurewinpe -wl
if %errorlevel% EQU 2 (
	bcdedit /store "%tbpath%\ISO\boot\BCD" /set {default} path \windows\system32\winload.exe > nul
	bcdedit /store "%tbpath%\ISO\EFI\Microsoft\Boot\BCD" /set {default} path \windows\system32\winload.efi > nul
)


:: ---------------------
:: Run BuildScript
:: ---------------------
if exist BuildScript.cmd (
	echo.
	echo Running BuildScript...
	echo.
	call BuildScript.cmd
	cd /d "!tbpath!"
)


:: --------------------
:: Modify WinPE files, resolution files, background, etc.
echo.
echo Finalizing WinPE build...
reg unload HKLM\TBWINPE_SYSTEM > nul
reg unload HKLM\TBWINPE_SOFTWARE > nul
reg unload HKLM\TBWINPE_DEFAULT > nul
copy "startnet.cmd" "mount\Windows\System32" > nul
if %usesavedsettings% EQU 1 if exist startnet_Saved.cmd (
	copy startnet_Saved.cmd "mount\Windows\system32\startnet.cmd" > nul
	del startnet_Saved.cmd > nul
)
if %createbootfile% EQU 1 (
	echo set textline "mount\Windows\System32\startnet.cmd" "bootfile /restore /noui /notifyos" /a "@echo off*" > tmpscript.run
	"!tbosdtpath!\win\tbosdtw.exe" tmpscript.run
	del tmpscript.run > nul
)
copy "chgres%tbx64%.exe" "mount\Windows\System32\chgres.exe" > nul
copy "ISO\TBData\TBWinPE.txt" "mount\Windows\System32\TBWinPE.txt" > nul

:: Set background image
copy "winpe.bmp" "mount\Windows\System32" > nul
if exist "mount\Windows\System32\winpe.jpg" (
	takeown /f "mount\Windows\System32\winpe.jpg" > nul
	icacls "mount\Windows\System32\winpe.jpg" /grant *S-1-5-32-544:F > nul
	del "mount\Windows\System32\winpe.jpg"
	copy "winpe.jpg" "mount\Windows\System32\winpe.jpg" > nul
)

:: Create shutdown.cmd
echo @echo off > "mount\Windows\System32\shutdown.cmd"
echo wpeutil shutdown >> "mount\Windows\System32\shutdown.cmd"

:: Add Drivers
if exist "Drivers" (
	echo.
	echo Adding drivers...
	"!dismpath!\Dism" /image:"mount" /Add-Driver /driver:"Drivers" /recurse /ForceUnsigned
)

:: Add Win7 USB3 Drivers
set Win7USB3DriversPath=Drivers_Win7PEUSB3\x86
if "%tbx64%"=="64" set Win7USB3DriversPath=Drivers_Win7PEUSB3\x64
if exist "mount\Windows\System32\winpeshl.exe_ver.6.1" if exist "%Win7USB3DriversPath%" (
	echo.
	echo Adding Windows 7 USB3 drivers...
	Dism /image:"!tbpath!\mount" /Add-Driver /driver:"!tbpath!\!Win7USB3DriversPath!" /recurse /ForceUnsigned
)
del "mount\Windows\System32\winpeshl.exe_ver.*" > nul 2>&1

:: This pause allows the advanced user to verify the contents of the mount folder
:: and to add additional files/folders.
if %pausebuild% EQU 1 (
	echo. & echo.
	echo --------------------------------------------------------------------------
	echo --[ Build Paused ]--------------------------------------------------------
	echo --------------------------------------------------------------------------
	echo The build has been paused to allow the mounted image to be checked or
	echo modified. Just press a key if unsure what to do.
	echo --------------------------------------------------------------------------
	echo.
	tbutil -pause -m "Press any key to continue with the build..."
	echo.
)


:: --------------------
:: Save & Unmount WinPE image
echo.
echo Saving WinPE image...
set /a dismsaveerror=0
"%dismpath%\Dism" /commit-Wim /MountDir:"mount"
if not %errorlevel% EQU 0 set /a dismsaveerror=1
echo.
echo Unmounting WinPE image (this may take several minutes)...
"%dismpath%\Dism" /unmount-Wim /MountDir:"mount" /discard
if %errorlevel% EQU 0 goto :skipUnmountError
echo.
echo --------------------------------------------------------------------------
echo --[ Unmount Error ]-------------------------------------------------------
echo --------------------------------------------------------------------------
echo The WinPE image couldn't be unmounted successfully. Please make sure
echo no programs (e.g. Explorer) are currently accessing the mount folder 
echo or its contents and then press a key to attempt another unmount.
echo.
echo Mount folder: %tbpath%\mount
echo --------------------------------------------------------------------------
echo.
tbutil -pause -m "Press any key to try the unmount again..."
echo.
echo Unmounting WinPE image (2nd attempt)...
"%dismpath%\Dism" /unmount-Wim /MountDir:"mount" /discard
if %errorlevel% EQU 0 goto :skipUnmountError
:: Delete mount folder and attempt cleanup
echo.
echo Attempting to remove mount folder...
if exist "mount" rd /s /q "mount" > nul
echo Attempting WIM cleanup...
"%dismpath%\Dism" /cleanup-wim
:skipUnmountError
if %dismsaveerror% EQU 1 goto :DISMSaveError
tbutil -configurewinpe -f
if %errorlevel% NEQ 1 echo WARNING: Error finalizing configuration!

:: Create TBWinPE.bin boot file
if %createbootfile% NEQ 1 goto :skipCreateBootFile
echo.
echo Creating boot file TBWinPE.bin...
(set bootfilesize=280)
tbutil -dirsize iso -s -q
if %errorlevel% GTR 0 (set /a bootfilesize=%errorlevel%+30)
echo del tbwinpe.bin /y > tmpscript.run
echo add virtdrv TBWinPE.bin %bootfilesize% TBWinPE /b /fat32 /bs=vistabs.f32 >> tmpscript.run
echo open fs 0: tbwinpe.bin >> tmpscript.run
echo copy file iso\*.* 0: /s /y >> tmpscript.run
echo close 0: >> tmpscript.run
"%tbosdtpath%\win\tbosdtw.exe" tmpscript.run > nul
del tmpscript.run > nul
echo :: This script will boot the TBWinPE.bin boot file. If the file has been > "Boot TBWinPE Boot File.cmd"
echo :: moved to a different path you will need to edit the path below. >> "Boot TBWinPE Boot File.cmd"
echo.  >> "Boot TBWinPE Boot File.cmd"
echo @echo off >> "Boot TBWinPE Boot File.cmd"
echo "%tbosdtpath%\win\bootfile%tbx64%.exe" "%tbpath%\TBWinPE.bin" >> "Boot TBWinPE Boot File.cmd"
echo Boot file created.
echo.
echo Run the "Boot TBWinPE Boot File.cmd" script to boot the system to the boot
echo file.
goto :BuildFinished
:skipCreateBootFile


:: --------------------
:: Launch MAKEDISK
echo.
echo Press a key to launch TeraByte's MAKEDISK utility to create the TBWinPE
echo CD, USB flash drive (UFD), or ISO file boot media.
echo.
tbutil -pause
echo.
echo Launching MAKEDISK...
start "" makedisk.exe

:BuildFinished
echo.
echo ==============================================================================
echo.
echo WinPE build process has finished.
echo.
echo ==============================================================================
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End



:: ---------------------------------------------------------------------

:: No IFW (imagew.exe) found
:NoIFW
echo.
echo Error: Can't find Image for Windows
echo.
echo Unsupported version or the file imagew%tbx64%.exe was not found in
echo %ifwpath%
echo.
if "%tbx64%"=="64" echo Make sure Image for Windows 2.71 or later is installed and that the correct 
if "%tbx64%"=="" echo Make sure Image for Windows is installed and that the correct
echo path is specified for Image for Windows in the script.
echo.
echo Script aborted.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End

:: No TBOSDT (tbosdtw.exe/bootfile.exe) found
:NoTBOSDT
echo.
echo Error: Can't find the TeraByte OS Deployment Tool Suite installation or
echo incorrect version installed.
echo.
echo Correct versions of tbosdtw.exe and bootfile.exe not found in
echo %tbosdtpath%\win
echo.
echo Make sure that the TeraByte OS Deployment Tool Suite version 1.47 or later is 
echo installed and that the correct path is specified in the script.
echo.
echo Script aborted.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End

:: No DISM.EXE found
:NoDISM
echo.
echo Error: Required program not found.
echo.
echo.   dism.exe not found in:
echo.   %dismpath%
echo.
echo Make sure the Windows 7 AIK or Windows 8/8.1/10/11 ADK is installed and that
echo the correct path is specified in the script.
echo.
echo Script aborted.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End

:WinPEWimNotFound
echo.
echo Error: Required file not found.
echo.
echo.   winpe.wim not found in:
echo.   %winpesource%
echo.
echo Make sure the Windows 7 AIK or Windows 8/8.1/10/11 ADK is installed and that
echo the correct path is specified in the script.
echo.
echo Script aborted.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End

:: Needs Administrator Privileges
:NonAdmin
echo.
echo TBWinPE.CMD requires administrator privileges to run. 
echo Please restart the script with the correct privileges.
echo.
echo Script aborted.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End

:DISMMountError
echo.
echo Error: Unable to mount winpe.wim.
echo.
echo Script aborted.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End

:DISMSaveError
echo.
echo Error: Unable to successfully save WinPE image.
echo.
echo Script aborted.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End

:CMDx64Required
echo.
echo This script requires being run from the 64-bit Command Prompt. To resolve,
echo run the script directly from Windows Explorer or from a 64-bit Command Prompt.
echo.
echo Script aborted.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :End


:: *****************************************
:: * Manage Settings
:: *****************************************
:ManageSettings
cls
echo.
echo ==============================================================================
echo   TeraByte WinPE Builder                                            ver. %tbwinpe_ver%
echo ==============================================================================
echo.
echo Manage Saved Settings
echo.
echo Please make a selection from the following choices:
echo.
echo   1 - Save current build settings
echo       (Saved settings will be retained when script is updated.)
echo.
if exist savedsettings.ini (
	echo   2 - Delete saved settings
	echo.
	if %usesavedsettings% EQU 0 echo   3 - Toggle using saved settings for build [Current state: Disabled]
	if %usesavedsettings% EQU 1 echo   3 - Toggle using saved settings for build [Current state: Enabled]
	echo.
	echo   4 - Return to main menu
	echo.
	tbutil -choice -c 1234 -m "Press the number of your selection: "
) else (
	echo   2 - Return to main menu
	echo.
	tbutil -choice -c 12 -e 1,4 -m "Press the number of your selection: "
)
if %errorlevel% EQU 4 goto :DisplayMenu
if %errorlevel% EQU 3 (
	if %usesavedsettings% EQU 1 set /a usesavedsettings=0
	if %usesavedsettings% EQU 0 set /a usesavedsettings=1
	tbutil -iniwrite SavedSettings.ini -s Options -k UseSavedSettings -v !usesavedsettings!
	goto :ManageSettings
)
if %errorlevel% EQU 2 (del savedsettings.ini) & (set /a usesavedsettings=0)
if %errorlevel% EQU 1 (
	echo. & echo.
	tbutil -savebuildsettings
	if !errorlevel! EQU 0 echo Settings successfully saved.
	if !errorlevel! EQU 1 echo An error occurred while saving settings.
	echo.
	tbutil -pause
)
goto :ManageSettings


:: *****************************************
:: * Language Pack Functions
:: *****************************************

:: Show Available Language Packs
:ShowLangPacks
echo. & echo.
echo The following is a list of the WinPE Language Packs available for
echo installation in TBWinPE. Make note of the Language Pack name you
echo wish to use. Edit the script when finished and set the 'languagepack'
echo variable to the selected name.
echo.
tbutil -pause -m "Press any key to begin..."

tbutil -console -row
set scrnhgt=%errorlevel%
if %scrnhgt% EQU 0 set scrnhgt=20
set /a scrnhgt=scrnhgt-2
set tzcnt=0

if %usesavedsettings% EQU 1 (
	for /f "usebackq tokens=* delims=" %%G in (`tbutil -iniread SavedSettings.ini -s Script_Options -k sourcepath -d _nopath_`) do set sourcepath=%%G
)
if exist "%sourcepath%\Assessment and Deployment Kit\Windows Preinstallation Environment\copype.cmd" (set sourcetype=1)

if %sourcetype% EQU 0 (set lp_path=!sourcepath!\Tools\PETools\amd64\WinPE_FPs)
if %sourcetype% EQU 1 (set lp_path=!sourcepath!\Assessment and Deployment Kit\Windows Preinstallation Environment\amd64\WinPE_OCs)

for /f "delims=" %%G in ('dir "!lp_path!\*.*" /ad /b /p /-p') do (
   echo.    %%G
   set /a tzcnt=!tzcnt!+1
   if !tzcnt! GTR %scrnhgt% (
	(set tzcnt=0)
	tbutil -pause -m "Press ESC to stop or any other key to view more names..."
	if !errorlevel! EQU 1 echo. & echo Language Pack listing aborted. & goto :EOF
   )
)

echo. & echo Language Pack listing finished.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :EOF


:: *****************************************
:: * Time Zone Functions
:: *****************************************

:: Show Time Zones
:ShowTimeZones
echo. & echo.
echo A numbered list of valid time zones will be displayed. Make note of the 
echo number that corresponds to the time zone you wish to use. Edit the script 
echo when finished and set the 'timezone' variable to the selected number.
echo.
tbutil -pause -m "Press any key to begin..."

tbutil -console -row
set scrnhgt=%errorlevel%
if %scrnhgt% EQU 0 set scrnhgt=20
set /a scrnhgt=scrnhgt-2
set tzcnt=0
for /L %%G in (1,1,98) do (
   call :ShowTimeZoneItem %%G
   set /a tzcnt=!tzcnt!+1
   if !tzcnt! GTR %scrnhgt% (
	(set tzcnt=0)
	tbutil -pause -m "Press ESC to stop or any other key to view more time zones..."
	if !errorlevel! EQU 1 echo. & echo Time Zone listing aborted. & goto :EOF
   )
)
echo. & echo Time Zone listing finished.
echo.
tbutil -pause -m "Press any key to exit script..."
goto :EOF

:: Show Time Zone Item
:ShowTimeZoneItem
if %1 GEQ 10 goto :tzjump10
if %1 EQU 1 (set timezonestr=Dateline Standard Time) & echo.  1 - (UTC-12:00) International Date Line West & goto :EOF
if %1 EQU 2 (set timezonestr=UTC-11) & echo.  2 - (UTC-11:00) Coordinated Universal Time-11 & goto :EOF
if %1 EQU 3 (set timezonestr=Samoa Standard Time) & echo.  3 - (UTC-11:00) Samoa & goto :EOF
if %1 EQU 4 (set timezonestr=Hawaiian Standard Time) & echo.  4 - (UTC-10:00) Hawaii & goto :EOF
if %1 EQU 5 (set timezonestr=Alaskan Standard Time) & echo.  5 - (UTC-09:00) Alaska & goto :EOF
if %1 EQU 6 (set timezonestr=Pacific Standard Time ^(Mexico^)) & echo.  6 - (UTC-08:00) Baja California & goto :EOF
if %1 EQU 7 (set timezonestr=Pacific Standard Time) & echo.  7 - (UTC-08:00) Pacific Time (US ^& Canada) & goto :EOF
if %1 EQU 8 (set timezonestr=US Mountain Standard Time) & echo.  8 - (UTC-07:00) Arizona & goto :EOF
if %1 EQU 9 (set timezonestr=Mountain Standard Time ^(Mexico^)) & echo.  9 - (UTC-07:00) Chihuahua, La Paz, Mazatlan & goto :EOF
:tzjump10
if %1 GEQ 20 goto :tzjump20
if %1 EQU 10 (set timezonestr=Mountain Standard Time) & echo. 10 - (UTC-07:00) Mountain Time (US ^& Canada) & goto :EOF
if %1 EQU 11 (set timezonestr=Central America Standard Time) & echo. 11 - (UTC-06:00) Central America & goto :EOF
if %1 EQU 12 (set timezonestr=Central Standard Time) & echo. 12 - (UTC-06:00) Central Time (US ^& Canada) & goto :EOF
if %1 EQU 13 (set timezonestr=Central Standard Time ^(Mexico^)) & echo. 13 - (UTC-06:00) Guadalajara, Mexico City, Monterrey & goto :EOF
if %1 EQU 14 (set timezonestr=Canada Central Standard Time) & echo. 14 - (UTC-06:00) Saskatchewan & goto :EOF
if %1 EQU 15 (set timezonestr=SA Pacific Standard Time) & echo. 15 - (UTC-05:00) Bogota, Lima, Quito & goto :EOF
if %1 EQU 16 (set timezonestr=Eastern Standard Time) & echo. 16 - (UTC-05:00) Eastern Time (US ^& Canada) & goto :EOF
if %1 EQU 17 (set timezonestr=US Eastern Standard Time) & echo. 17 - (UTC-05:00) Indiana (East) & goto :EOF
if %1 EQU 18 (set timezonestr=Venezuela Standard Time) & echo. 18 - (UTC-04:30) Caracas & goto :EOF
if %1 EQU 19 (set timezonestr=Paraguay Standard Time) & echo. 19 - (UTC-04:00) Asuncion & goto :EOF
:tzjump20
if %1 GEQ 30 goto :tzjump30
if %1 EQU 20 (set timezonestr=Atlantic Standard Time) & echo. 20 - (UTC-04:00) Atlantic Time (Canada) & goto :EOF
if %1 EQU 21 (set timezonestr=Central Brazilian Standard Time) & echo. 21 - (UTC-04:00) Cuiaba & goto :EOF
if %1 EQU 22 (set timezonestr=SA Western Standard Time) & echo. 22 - (UTC-04:00) Georgetown, La Paz, Manaus, San Juan & goto :EOF
if %1 EQU 23 (set timezonestr=Pacific SA Standard Time) & echo. 23 - (UTC-04:00) Santiago & goto :EOF
if %1 EQU 24 (set timezonestr=Newfoundland Standard Time) & echo. 24 - (UTC-03:30) Newfoundland & goto :EOF
if %1 EQU 25 (set timezonestr=E. South America Standard Time) & echo. 25 - (UTC-03:00) Brasilia & goto :EOF
if %1 EQU 26 (set timezonestr=Argentina Standard Time) & echo. 26 - (UTC-03:00) Buenos Aires & goto :EOF
if %1 EQU 27 (set timezonestr=SA Eastern Standard Time) & echo. 27 - (UTC-03:00) Cayenne, Fortaleza & goto :EOF
if %1 EQU 28 (set timezonestr=Greenland Standard Time) & echo. 28 - (UTC-03:00) Greenland & goto :EOF
if %1 EQU 29 (set timezonestr=Montevideo Standard Time) & echo. 29 - (UTC-03:00) Montevideo & goto :EOF
:tzjump30
if %1 GEQ 40 goto :tzjump40
if %1 EQU 30 (set timezonestr=UTC-02) & echo. 30 - (UTC-02:00) Coordinated Universal Time-02 & goto :EOF
if %1 EQU 31 (set timezonestr=Mid-Atlantic Standard Time) & echo. 31 - (UTC-02:00) Mid-Atlantic & goto :EOF
if %1 EQU 32 (set timezonestr=Azores Standard Time) & echo. 32 - (UTC-01:00) Azores & goto :EOF
if %1 EQU 33 (set timezonestr=Cape Verde Standard Time) & echo. 33 - (UTC-01:00) Cape Verde Is. & goto :EOF
if %1 EQU 34 (set timezonestr=Morocco Standard Time) & echo. 34 - (UTC) Casablanca & goto :EOF
if %1 EQU 35 (set timezonestr=UTC) & echo. 35 - (UTC) Coordinated Universal Time & goto :EOF
if %1 EQU 36 (set timezonestr=GMT Standard Time) & echo. 36 - (UTC) Dublin, Edinburgh, Lisbon, London & goto :EOF
if %1 EQU 37 (set timezonestr=Greenwich Standard Time) & echo. 37 - (UTC) Monrovia, Reykjavik & goto :EOF
if %1 EQU 38 (set timezonestr=W. Europe Standard Time) & echo. 38 - (UTC+01:00) Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna & goto :EOF
if %1 EQU 39 (set timezonestr=Central Europe Standard Time) & echo. 39 - (UTC+01:00) Belgrade, Bratislava, Budapest, Ljubljana, Prague & goto :EOF
:tzjump40
if %1 GEQ 50 goto :tzjump50
if %1 EQU 40 (set timezonestr=Romance Standard Time) & echo. 40 - (UTC+01:00) Brussels, Copenhagen, Madrid, Paris & goto :EOF
if %1 EQU 41 (set timezonestr=Central European Standard Time) & echo. 41 - (UTC+01:00) Sarajevo, Skopje, Warsaw, Zagreb & goto :EOF
if %1 EQU 42 (set timezonestr=W. Central Africa Standard Time) & echo. 42 - (UTC+01:00) West Central Africa & goto :EOF
if %1 EQU 43 (set timezonestr=Namibia Standard Time) & echo. 43 - (UTC+01:00) Windhoek & goto :EOF
if %1 EQU 44 (set timezonestr=Jordan Standard Time) & echo. 44 - (UTC+02:00) Amman & goto :EOF
if %1 EQU 45 (set timezonestr=GTB Standard Time) & echo. 45 - (UTC+02:00) Athens, Bucharest, Istanbul & goto :EOF
if %1 EQU 46 (set timezonestr=Middle East Standard Time) & echo. 46 - (UTC+02:00) Beirut & goto :EOF
if %1 EQU 47 (set timezonestr=Egypt Standard Time) & echo. 47 - (UTC+02:00) Cairo & goto :EOF
if %1 EQU 48 (set timezonestr=Syria Standard Time) & echo. 48 - (UTC+02:00) Damascus & goto :EOF
if %1 EQU 49 (set timezonestr=South Africa Standard Time) & echo. 49 - (UTC+02:00) Harare, Pretoria & goto :EOF
:tzjump50
if %1 GEQ 60 goto :tzjump60
if %1 EQU 50 (set timezonestr=FLE Standard Time) & echo. 50 - (UTC+02:00) Helsinki, Kyiv, Riga, Sofia, Tallinn, Vilnius & goto :EOF
if %1 EQU 51 (set timezonestr=Israel Standard Time) & echo. 51 - (UTC+02:00) Jerusalem & goto :EOF
if %1 EQU 52 (set timezonestr=E. Europe Standard Time) & echo. 52 - (UTC+02:00) Minsk & goto :EOF
if %1 EQU 53 (set timezonestr=Arabic Standard Time) & echo. 53 - (UTC+03:00) Baghdad & goto :EOF
if %1 EQU 54 (set timezonestr=Arab Standard Time) & echo. 54 - (UTC+03:00) Kuwait, Riyadh & goto :EOF
if %1 EQU 55 (set timezonestr=Russian Standard Time) & echo. 55 - (UTC+03:00) Moscow, St. Petersburg, Volgograd & goto :EOF
if %1 EQU 56 (set timezonestr=E. Africa Standard Time) & echo. 56 - (UTC+03:00) Nairobi & goto :EOF
if %1 EQU 57 (set timezonestr=Iran Standard Time) & echo. 57 - (UTC+03:30) Tehran & goto :EOF
if %1 EQU 58 (set timezonestr=Arabian Standard Time) & echo. 58 - (UTC+04:00) Abu Dhabi, Muscat & goto :EOF
if %1 EQU 59 (set timezonestr=Azerbaijan Standard Time) & echo. 59 - (UTC+04:00) Baku & goto :EOF
:tzjump60
if %1 GEQ 70 goto :tzjump70
if %1 EQU 60 (set timezonestr=Mauritius Standard Time) & echo. 60 - (UTC+04:00) Port Louis & goto :EOF
if %1 EQU 61 (set timezonestr=Georgian Standard Time) & echo. 61 - (UTC+04:00) Tbilisi & goto :EOF
if %1 EQU 62 (set timezonestr=Caucasus Standard Time) & echo. 62 - (UTC+04:00) Yerevan & goto :EOF
if %1 EQU 63 (set timezonestr=Afghanistan Standard Time) & echo. 63 - (UTC+04:30) Kabul & goto :EOF
if %1 EQU 64 (set timezonestr=Ekaterinburg Standard Time) & echo. 64 - (UTC+05:00) Ekaterinburg & goto :EOF
if %1 EQU 65 (set timezonestr=Pakistan Standard Time) & echo. 65 - (UTC+05:00) Islamabad, Karachi & goto :EOF
if %1 EQU 66 (set timezonestr=West Asia Standard Time) & echo. 66 - (UTC+05:00) Tashkent & goto :EOF
if %1 EQU 67 (set timezonestr=India Standard Time) & echo. 67 - (UTC+05:30) Chennai, Kolkata, Mumbai, New Delhi & goto :EOF
if %1 EQU 68 (set timezonestr=Sri Lanka Standard Time) & echo. 68 - (UTC+05:30) Sri Jayawardenepura & goto :EOF
if %1 EQU 69 (set timezonestr=Nepal Standard Time) & echo. 69 - (UTC+05:45) Kathmandu & goto :EOF
:tzjump70
if %1 GEQ 80 goto :tzjump80
if %1 EQU 70 (set timezonestr=Central Asia Standard Time) & echo. 70 - (UTC+06:00) Astana & goto :EOF
if %1 EQU 71 (set timezonestr=Bangladesh Standard Time) & echo. 71 - (UTC+06:00) Dhaka & goto :EOF
if %1 EQU 72 (set timezonestr=N. Central Asia Standard Time) & echo. 72 - (UTC+06:00) Novosibirsk & goto :EOF
if %1 EQU 73 (set timezonestr=Myanmar Standard Time) & echo. 73 - (UTC+06:30) Yangon (Rangoon) & goto :EOF
if %1 EQU 74 (set timezonestr=SE Asia Standard Time) & echo. 74 - (UTC+07:00) Bangkok, Hanoi, Jakarta & goto :EOF
if %1 EQU 75 (set timezonestr=North Asia Standard Time) & echo. 75 - (UTC+07:00) Krasnoyarsk & goto :EOF
if %1 EQU 76 (set timezonestr=China Standard Time) & echo. 76 - (UTC+08:00) Beijing, Chongqing, Hong Kong, Urumqi & goto :EOF
if %1 EQU 77 (set timezonestr=North Asia East Standard Time) & echo. 77 - (UTC+08:00) Irkutsk & goto :EOF
if %1 EQU 78 (set timezonestr=Singapore Standard Time) & echo. 78 - (UTC+08:00) Kuala Lumpur, Singapore & goto :EOF
if %1 EQU 79 (set timezonestr=W. Australia Standard Time) & echo. 79 - (UTC+08:00) Perth & goto :EOF
:tzjump80
if %1 GEQ 90 goto :tzjump90
if %1 EQU 80 (set timezonestr=Taipei Standard Time) & echo. 80 - (UTC+08:00) Taipei & goto :EOF
if %1 EQU 81 (set timezonestr=Ulaanbaatar Standard Time) & echo. 81 - (UTC+08:00) Ulaanbaatar & goto :EOF
if %1 EQU 82 (set timezonestr=Tokyo Standard Time) & echo. 82 - (UTC+09:00) Osaka, Sapporo, Tokyo & goto :EOF
if %1 EQU 83 (set timezonestr=Korea Standard Time) & echo. 83 - (UTC+09:00) Seoul & goto :EOF
if %1 EQU 84 (set timezonestr=Yakutsk Standard Time) & echo. 84 - (UTC+09:00) Yakutsk & goto :EOF
if %1 EQU 85 (set timezonestr=Cen. Australia Standard Time) & echo. 85 - (UTC+09:30) Adelaide & goto :EOF
if %1 EQU 86 (set timezonestr=AUS Central Standard Time) & echo. 86 - (UTC+09:30) Darwin & goto :EOF
if %1 EQU 87 (set timezonestr=E. Australia Standard Time) & echo. 87 - (UTC+10:00) Brisbane & goto :EOF
if %1 EQU 88 (set timezonestr=AUS Eastern Standard Time) & echo. 88 - (UTC+10:00) Canberra, Melbourne, Sydney & goto :EOF
if %1 EQU 89 (set timezonestr=West Pacific Standard Time) & echo. 89 - (UTC+10:00) Guam, Port Moresby & goto :EOF
:tzjump90
if %1 EQU 90 (set timezonestr=Tasmania Standard Time) & echo. 90 - (UTC+10:00) Hobart & goto :EOF
if %1 EQU 91 (set timezonestr=Vladivostok Standard Time) & echo. 91 - (UTC+10:00) Vladivostok & goto :EOF
if %1 EQU 92 (set timezonestr=Magadan Standard Time) & echo. 92 - (UTC+11:00) Magadan & goto :EOF
if %1 EQU 93 (set timezonestr=Central Pacific Standard Time) & echo. 93 - (UTC+11:00) Solomon Is., New Caledonia & goto :EOF
if %1 EQU 94 (set timezonestr=New Zealand Standard Time) & echo. 94 - (UTC+12:00) Auckland, Wellington & goto :EOF
if %1 EQU 95 (set timezonestr=UTC+12) & echo. 95 - (UTC+12:00) Coordinated Universal Time+12 & goto :EOF
if %1 EQU 96 (set timezonestr=Fiji Standard Time) & echo. 96 - (UTC+12:00) Fiji & goto :EOF
if %1 EQU 97 (set timezonestr=Kamchatka Standard Time) & echo. 97 - (UTC+12:00) Petropavlovsk-Kamchatsky - Old & goto :EOF
if %1 EQU 98 (set timezonestr=Tonga Standard Time) & echo. 98 - (UTC+13:00) Nuku'alofa & goto :EOF
goto :EOF


:: *****************************************
:: * Final Script Cleanup
:: *****************************************

:End
endlocal
